from .ftdi import Ftdi as Ftdi
from _typeshed import Incomplete
from typing import Union

class FtdiMpsseTracer:
    MPSSE_ENGINES: Incomplete
    def __init__(self, version) -> None: ...
    def send(self, iface: int, buf: Union[bytes, bytearray]) -> None: ...
    def receive(self, iface: int, buf: Union[bytes, bytearray]) -> None: ...

class FtdiMpsseEngine:
    COMMAND_PREFIX: str
    def build_commands(prefix: str): ...
    COMMANDS: Incomplete
    ST_IDLE: Incomplete
    log: Incomplete
    def __init__(self, iface: int) -> None: ...
    def send(self, buf: Union[bytes, bytearray]) -> None: ...
    def receive(self, buf: Union[bytes, bytearray]) -> None: ...
    @classmethod
    def bit2str(cls, value: int, count: int, msb: bool, hiz: str = ...) -> str: ...
    @classmethod
    def bm2str(cls, value: int, mask: int, hiz: str = ...) -> str: ...
    @classmethod
    def bitfmt(cls, value, width): ...
